unit oScriptColumn;

interface

uses
  Dialogs,
  SysUtils,
  Windows,
  Messages,
  Classes,
  Graphics,
  Controls,
  Forms,
  XMLIntf,
  Variants,
  oScriptTypes;

type
  TScriptColumn = class(TObject)
  private
    fComment: string;
    fFMFieldNumber: string;
    fFMFieldFormat: boolean;
    fFMFieldType: TFMFieldType;
    fXMLTag: string;
  public
    property Comment: string read fComment write fComment;
    property FMFieldNumber: string read fFMFieldNumber write fFMFieldNumber;
    property FInternalFormat: boolean read fFMFieldFormat write fFMFieldFormat;
    property FMFieldType: TFMFieldType read fFMFieldType write fFMFieldType;
    property XMLTag: string read fXMLTag write fXMLTag;
  end;

function NewScriptColumn(aXMLNode: IXMLNode): TScriptColumn;

implementation

function NewScriptColumn(aXMLNode: IXMLNode): TScriptColumn;
begin
  Result := TScriptColumn.Create;
  with Result do
    try
      fXMLTag := aXMLNode.Attributes['TAG'];
      fFMFieldNumber := VarToStrDef(aXMLNode.ChildValues['FM_FIELD'], '');
      fFMFieldType := aXMLNode.ChildValues['FM_DATATYPE'];
      fInternalFormat := aXMLNode.ChildValues['INTERNAL_FORMAT'];
      fComment := aXMLNode.ChildValues['COMMENT'];
    except
      on e: Exception do
        begin
          MessageDlg('Error Loading node ' + #13 + e.Message + #13 + ffmFieldNumber, mtError, [mbOk], 0);
          FreeAndNil(Result);
        end;
    end;
end;

end.

