unit oTerminologyEnumerator;

interface

uses
  Classes,
  SysUtils,
  iCPTerminology;

type
  TTerminologyEnumerator = class(TInterfacedObject, ITerminologyEnumerator)
  private
    fList: IInterfaceList;
    fIndex: integer;
  public
    constructor Create(aList: IInterfaceList);
    destructor Destroy; override;

    function GetCurrentIndex: integer; stdcall;
    function GetPercentageDone: integer; stdcall;
    function GetCurrentTerm: ITerm; stdcall;
    function MoveNext: boolean; stdcall;
  end;

implementation

{ TTermListEnumerator }

constructor TTerminologyEnumerator.Create(aList: IInterfaceList);
begin
  inherited Create;
  fList := aList;
  fIndex := -1;
end;

destructor TTerminologyEnumerator.Destroy;
begin
  inherited;
end;

function TTerminologyEnumerator.GetCurrentIndex: integer;
begin
  Result := fIndex;
end;

function TTerminologyEnumerator.GetCurrentTerm: ITerm;
begin
  fList[fIndex].QueryInterface(ITerm, Result);
end;

function TTerminologyEnumerator.GetPercentageDone: integer;
begin
  Result := trunc((fIndex / fList.Count) * 100);
end;

function TTerminologyEnumerator.MoveNext: boolean;
begin
  Result := fIndex < fList.Count - 1;
  if Result then
    Inc(fIndex);
end;

end.

