unit fMain;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 6 $  $Modtime: 1/31/07 11:45a $
*       Developer:    dan.petit@va.gov
*       Site:         Hines OIFO
*
*       Description:  Developer Testing Unit.
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Modernization/CliO/source/TGridFrame/fMain.pas $
*
* $History: fMain.pas $
 * 
 * *****************  Version 6  *****************
 * User: Zzzzzzpetitd Date: 2/23/07    Time: 1:59p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * Post CMO conference
 *
 * *****************  Version 5  *****************
 * User: Zzzzzzpetitd Date: 12/11/06   Time: 1:58p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * Demo released to testing and documentation
 *
 * *****************  Version 4  *****************
 * User: Zzzzzzpetitd Date: 11/24/06   Time: 4:28p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * Implementation of non-modal input in the main form.
 *
 * *****************  Version 3  *****************
 * User: Zzzzzzpetitd Date: 11/09/06   Time: 3:03p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * Weekly update of all changes.
 *
 * *****************  Version 2  *****************
 * User: Zzzzzzpetitd Date: 10/23/06   Time: 4:07p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * Finished Pivots, Parser Key, and Totals.
 *
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 10/05/06   Time: 12:59p
 * Created in $/CP Modernization/CliO/source/TGridFrame
 * Initial Check-In
 *
*
================================================================================
}
interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  Printers,
  iCliOGrid,
  StdCtrls,
  XPMan,
  ExtCtrls;

type
  TfrmMain = class(TForm)
    ScrollBox1: TScrollBox;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    function getWidgets(aList: IInterfaceList): integer; stdcall;
    function getWidgetIndex(aGridInterface: IInterface; aWidget: IInterface): integer; stdcall;
    function CloseMe(aGridInterface: IInterface): boolean; stdcall;
    function getWidgetProperties(aItem: IInterface): boolean; stdcall;
  end;

var
  frmMain: TfrmMain;

implementation

uses
  DateUtils,
  oWidget;

var
  MyGridFrame: IGridFrame;
  MyItems: IInterfaceList;

const
  NOTE_TITLES: array[0..5] of string = ('Progress Note', 'Social Work Assessment', 'Lab Results', 'Patient Education', 'Radiology Procedure Report', 'EKG Assessment');

{$R *.dfm}

procedure TfrmMain.FormCreate(Sender: TObject);
var
  i: integer;
begin
  Font := Screen.IconFont;
  MyItems := TInterfaceList.Create;
  i := 20; //MinuteOfTheDay(Now) - 20;

  while MyItems.Count < 10 do
    MyItems.Add(
      NewWidget(
      IncMinute(Now, Random(i) * -1),
      'Notes',
      NOTE_TITLES[Random(6)]));

  MyGridFrame := NewGridFrame(ScrollBox1, nil);
  with MyGridFrame do
    try
      BeginUpdate;
      OnGridFetchData := getWidgets;
      OnGridFindTerm := getWidgetIndex;
      OnGridClose := CloseMe;
      OnGridClickItem := getWidgetProperties;

      AddTerm(NewGridTerm('Notes', 450));

      setTitle('Progress Notes and other widgets');
      setTermsOnXAxis(False);
      setInterval(240);
      setExpanded(True);

      setIncludeTotals(False);
      setIncludeCounts(True);
      setIncludeAverages(False);
      setStartDate(trunc(Now));
      setStopDate(now);
    finally
      EndUpdate;
    end;
  MyGridFrame.Refresh;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MyGridFrame := nil;
  Action := caFree;
end;

function TfrmMain.getWidgetProperties(aItem: IInterface): boolean;
var
  aGridItem: IGridItem;
begin
  if aItem.QueryInterface(IGridItem, aGridItem) = 0 then
    begin
      MessageDlg(
        'Welcome to the developer designed YouClickedIt method.' + #13 +
        'You clicked on ' + aGridItem.getDisplayValue + ' somwhere and got sent here.',
        mtInformation, [mbOk], 0);
      Result := True;
    end;
  aGridItem := nil;
end;

function TfrmMain.getWidgetIndex(aGridInterface: IInterface; aWidget: IInterface): integer;
begin
  Result := 0;
end;

function TfrmMain.getWidgets(aList: IInterfaceList): integer;
var
  i: integer;
begin
  aList.Clear;
  for i := 0 to MyItems.Count - 1 do
    aList.Add(MyItems[i]);
  Result := aList.Count;
end;

function TfrmMain.CloseMe(aGridInterface: IInterface): boolean;
begin
  ShowMessage('Request made to close grid');
end;

end.

