unit oGridDateTime;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 1 $  $Modtime: 11/10/07 12:47p $
*       Developer:    dan.petit@va.gov
*       Site:         Hines OIFO
*
*       Description:  Used within the CLiO grid for date/time management.
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Modernization/CliO/source/TGridFrame/oGridDateTime.pas $
*
* $History: oGridDateTime.pas $
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 11/10/07   Time: 12:59p
 * Created in $/CP Modernization/CliO/source/TGridFrame
 * 
 * *****************  Version 2  *****************
 * User: Zzzzzzpetitd Date: 4/03/07    Time: 9:43a
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 *
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 10/05/06   Time: 1:01p
 * Created in $/CP Modernization/CliO/source/TGridFrame
 * Initial Check-In
 *
*
================================================================================
}
interface

uses
  Classes,
  SysUtils,
  DateUtils,
  iCliOGrid;

type
  TGridDateTime = class(TInterfacedObject, IGridDateTime)
  private
    fDateTime: TDateTime;
    fInterval: integer;
  public
    function _AddRef: integer; stdcall;
    function _Release: integer; stdcall;
    function getDate: string; stdcall;
    function getTime: string; stdcall;
    function getDateTime: string; stdcall;
    function DateTime: TDateTime; stdcall;
  end;

function NewGridDateTime(aDateTime: TDateTime; aInterval: integer = 0): TGridDateTime;

implementation

function NewGridDateTime(aDateTime: TDateTime; aInterval: integer = 0): TGridDateTime;
begin
  Result := TGridDateTime.Create;
  Result.fDateTime := aDateTime;
  Result.fInterval := aInterval;
end;

{ TGridDateTime }

function TGridDateTime._AddRef: integer;
begin
  Result := -1;
end;

function TGridDateTime._Release: integer;
begin
  Result := -1;
end;

function TGridDateTime.getDate: string;
begin
  if frac(fDateTime) > 0 then
    Result := ''
  else
    Result := FormatDateTime('mmm-dd-yy', fDateTime);
end;

function TGridDateTime.getTime: string;
begin
  Result := FormatDateTime('hh:mm', fDateTime);
  if fInterval > 0 then
    Result := Result + ' - ' + FormatDateTime('hh:mm', IncMinute(fDateTime, fInterval - 1));
end;

function TGridDateTime.getDateTime: string;
begin
  Result := FormatDateTime('yyyy-mm-dd hh:mm:ss', fDateTime);
end;

function TGridDateTime.DateTime: TDateTime;
begin
  Result := fDateTime;
end;

end.

